--[[
                    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----

					
                        #########  #      #  #    ####           ####       ####      ####      #   #    #######    #
                            #      #      #  #  ##    ##       ##    ##   ##    ##   ##  ##    ### ###   #     ##   #
                            #      #      #  #  #      #       #      #  ##         #      #  #  # #  #  #       #  #
                            #      #      #  #  ##             ##        #          #      #  #   #   #  #     ##   #
                            #      ########  #   ######         ######   #          ########  #   #   #  #######    #
                            #      #      #  #        ##             ##  #          #      #  #   #   #  #          #
                            #      #      #  #  #      #       #      #  ##         #      #  #   #   #  #          #
                            #      #      #  #  ##    ##       ##    ##   ##    ##  #      #  #   #   #  #          #
                            #      #      #  #    ####           ####       ####    #      #  #   #   #  #          #


                            #      #    ####    #######    #######    ########  #       #  #  #       #     ####
                            #      #   ##  ##   #     ##   #     ##   #         ##      #  #  ##      #   ##    ##
                            #      #  #      #  #       #  #       #  #         # #     #  #  # #     #  ##
                            #      #  #      #  #     ##   #     ##   #         #  #    #  #  #  #    #  #
                            ########  ########  #######    #######    ########  #   #   #  #  #   #   #  #
                            #      #  #      #  #          #          #         #    #  #  #  #    #  #  #     ###
                            #      #  #      #  #          #          #         #     # #  #  #     # #  ##      #
                            #      #  #      #  #          #          #         #      ##  #  #      ##   ##    ##
                            #      #  #      #  #          #          ########  #       #  #  #       #     ####


                                                             --==  VANILLA  ==--
                                                       --==  THE BURNING CRUSADE  ==--
                                                       --==  WARLORDS OF DRAENOR  ==--
                                                             --==  LEGION  ==--
                                                       --==  BATTLE FOR AZEROTH  ==--


                    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                                                    ----o----(||)----oo----(||)----o----

                                                          v2.03 1st September 2018
                                                    Copyright (C) Taraezor / Chris Birch

                                                    ----o----(||)----oo----(||)----o----


]]

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Localisations and Local Data
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local addonName, addonTitle = "ThisScampiHappening";

local date = date
local find = string.find
local gmatch = string.gmatch or string.gfind		-- LUA 5.0 -> 5.1 renamed gfind to gmatch. This in case 5.0 is used
local gsub = string.gsub
local ipairs = ipairs
local lower = string.lower
local pairs = pairs
local random = random
local select = select
local strsplit = strsplit
local sub = string.sub
local tonumber = tonumber
local tostring = tostring

local EnumerateFrames = EnumerateFrames
local GetActionText = GetActionText
local GetAddOnMetadata = GetAddOnMetadata
local GetAuctionItemLink = GetAuctionItemLink
local GetBuybackItemInfo = GetBuybackItemInfo
local GetBuybackItemLink = GetBuybackItemLink
local GetContainerItemLink = GetContainerItemLink
local GetGuildBankItemLink = GetGuildBankItemLink
local GetInboxItemLink = GetInboxItemLink
local GetInventoryItemLink = GetInventoryItemLink
local GetItemInfo = GetItemInfo
local GetLootRollItemLink = GetLootRollItemLink
local GetLootSlotLink = GetLootSlotLink
local GetMerchantItemLink = GetMerchantItemLink
local GetPlayerBuff = GetPlayerBuff
local GetQuestItemLink = GetQuestItemLink
local GetQuestLogItemLink = GetQuestLogItemLink
local GetSendMailItem = GetSendMailItem
local GetSendMailItemLink = GetSendMailItemLink
local GetTime = GetTime
local GetTradeSkillItemLink = GetTradeSkillItemLink
local GetTradeSkillReagentItemLink = GetTradeSkillReagentItemLink
local MouseIsOver = MouseIsOver
local UnitAura = UnitAura
local UnitBuff = UnitBuff
local UnitCreatureType = UnitCreatureType
local UnitDebuff = UnitDebuff
local UnitGUID = UnitGUID
local UnitIsPlayer = UnitIsPlayer
local UnitName = UnitName

if C_TradeSkillUI then
	local TradeSkillUIGetRecipeItemLink = C_TradeSkillUI.GetRecipeItemLink
	local TradeSkillUIGetRecipeReagentItemLink = C_TradeSkillUI.GetRecipeReagentItemLink
end

local _G = getfenv(0)

local defaultDelay = 300
local spaceLine = ""

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Build / Version Setup
--		=====================
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- In Lua 5.0 we have the table.getn( puns ) function for table length. From Lua 5.1 we use # and getn is deprecated. So we are stuck!

local buildVersion = GetBuildInfo()
local booleanTrue;
local _, _, buildVersionMajor, buildVersionMinor, _ = find( buildVersion, "(%d+)\.(%d+)" )
local _, _, luaVersionMinor = find( (_VERSION or "Lua 5.0"), "%d+\.(%d+)" )
if ( buildVersionMajor < "3" ) then
	booleanTrue = 1
else
	booleanTrue = true
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Fishing Items/NPCs/Spells/Text
--		==============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local wearableFishing = {
			["10 Pound Mud Snapper"] = true,
			["12 Pound Mud Snapper"] = true,
			["15 Pound Mud Snapper"] = true,
			["15 Pound Salmon"] = true,
			["17 Pound Catfish"] = true,
			["18 Pound Salmon"] = true,
			["19 Pound Catfish"] = true,
			["22 Pound Catfish"] = true,
			["22 Pound Salmon"] = true,
			["25 Pound Salmon"] = true,
			["26 Pound Catfish"] = true,
			["29 Pound Salmon"] = true,
			["32 Pound Catfish"] = true,
			["32 Pound Salmon"] = true,
			["34 Pound Redgill"] = true,
			["37 Pound Redgill"] = true,
			["42 Pound Redgill"] = true,
			["45 Pound Redgill"] = true,
			["49 Pound Redgill"] = true,
			["52 Pound Redgill"] = true,
			["70 Pound Mightfish"] = true,
			["85 Pound Mightfish"] = true,
			["92 Pound Mightfish"] = true,
			["103 Pound Mightfish"] = true,
			["Admiral Taylor's Loyalty Ring"] = true,
			["Anglin' Art's Sandals"] = true,
			["Antique Silver Cufflinks"] = true,
			["Bloodied Prison Shank"] = true,
			["Boots of the Bay"] = true,
			["Broken Wine Bottle"] = true,
			["Captain Sander's Returned Band"] = true,
			["Crafty's Pole"] = true,
			["Dark Herring"] = true,
			["Diamond-Tipped Cane"] = true,
			["Dread Pirate Ring"] = true,
			["Dustbringer"] = true,
			["Enormous Barbed Gill Trout"] = true,
			["Feralas Ahi"] = true,
			["Fish Gutter"] = true,
			["Fish-Eye Poker"] = true,
			["Fishy Cinch"] = true,
			["Fishmonger's Blade"] = true,
			["Forgotten Necklace"] = true,
			["Gold Wedding Band"] = true,
			["Hightfish Cap"] = true,
			["Huge Spotted Feltail"] = true,
			["Lost Ring"] = true,
			["Nat's Drinking Hat"] = true,
			["Nat's Hat"] = true,
			["Noble's Monocle"] = true,
			["Old Crafty"] = true,
			["Old Ironjaw"] = true,
			["Ornate Drinking Stein"] = true,
			["Razor Sharp Fillet Knife"] = true,
			["Rockhide Strongfish"] = true,
			["Sharpened Tuskarr Spear"] = true,
			["Signet of the Third Fleet"] = true,
			["Steelscale Crushfish"] = true,
			["Stendel's Bane"] = true,
			["Stendel's Wedding Band"] = true,
			["Tentacled Hat"] = true,
			["The 1 Ring"] = true,
			["The 2 Ring"] = true,
			["The 5 Ring"] = true,
}

local nonWearableFishing = {
			["7 Pound Lobster"] = true,
			["9 Pound Lobster"] = true,
			["12 Pound Lobster"] = true,
			["15 Pound Lobster"] = true,
			["19 Pound Lobster"] = true,
			["21 Pound Lobster"] = true,
			["22 Pound Lobster"] = true,
			["40 Pound Grouper"] = true,
			["47 Pound Grouper"] = true,
			["53 Pound Grouper"] = true,
			["59 Pound Grouper"] = true,
			["68 Pound Grouper"] = true,
			["Abyssal Gulper Eel Bait"] = true,
			["Abyssal Gulper Eel Egg"] = true,
			["Abyssal Gulper Lunker"] = true,
			["Alchemical Bonding Agent"] = true,
			["Alliance Decoy Kit"] = true,
			["Amorous Mud Snapper"] = true,
			["Ancient Black Barracuda"] = true,
			["Ancient Highmountain Salmon"] = true,
			["Ancient Mossgill"] = true,
			["Ancient Shark Jaws"] = true,
			["Ancient Totem Fragment"] = true,
			["Ancient Vrykul Ring"] = true,
			["Anduin Wrynn's Gold Coin"] = true,
			["Anglin' Art's Bag o' Fish"] = true,
			["Anglin' Art's Mudfish Bait"] = true,
			["Anuniaq's Net"] = true,
			["Aqua Jewel"] = true,
			["Aquadynamic Fish Attractor"] = true,
			["Aquadynamic Fish Lens"] = true,
			["Arcane Lure"] = true,
			["Arcane Trout"] = true,
			["Archimonde's Gold Coin"] = true,
			["Arctic Char"] = true,
			["Armored Carp"] = true,
			["Aromatic Murloc Slime"] = true,
			["Arthas' Gold Coin"] = true,
			["Arugal's Gold Coin"] = true,
			["Auripagic Sardine"] = true,
			["Awesomefish"] = true,
			["Axefish"] = true,
			["Axefish Lure"] = true,
			["Azshara Snakehead"] = true,
			["Baby Crocolisk"] = true,
			["Baby Octopus"] = true,
			["Bag of Clams"] = true,
			["Bag of Shiny Things"] = true,
			["Bait-o-Matic Blueprints"] = true,
			["Barrel of Fish"] = true,
			["Barrel of Fish Oil"] = true,
			["Battered Chest"] = true,
			["Battered Jungle Hat"] = true,
			["Beloved Ring"] = true,
			["Bipsi's Bobbing Berg"] = true,
			["Blackfin Darter"] = true,
			["Blackwater Whiptail Bait"] = true,
			["Blackwater Whiptail Egg"] = true,
			["Blackwater Whiptail Lunker"] = true,
			["Blacktip Shark"] = true,
			["Bladebone Hook"] = true,
			["Blank Slate"] = true,
			["Blind Cavefish"] = true,
			["Blind Lake Sturgeon Bait"] = true,
			["Blind Lake Sturgeon Egg"] = true,
			["Blind Lake Sturgeon Lunker"] = true,
			["Blind Minnow"] = true,
			["Bloated Albacore"] = true,
			["Bloated Barbed Gill Trout"] = true,
			["Bloated Catfish"] = true,
			["Bloated Frog"] = true,
			["Bloated Giant Sunfish"] = true,
			["Bloated Mackerel"] = true,
			["Bloated Mud Snapper"] = true,
			["Bloated Slippery Eel"] = true,
			["Bloated Smallfish"] = true,
			["Bloated Redgill"] = true,
			["Bloated Rockscale Cod"] = true,
			["Bloated Salmon"] = true,
			["Bloated Thresher"] = true,
			["Bloated Trout"] = true,
			["Bloodtooth Frenzy"] = true,
			["Blorp's Bubble"] = true,
			["Bold Stormjewel"] = true,
			["Brann Bronzebeard's Gold Coin"] = true,
			["Bright Baubles"] = true,
			["Brilliant Stormjewel"] = true,
			["Brinedeep Bottom-Feeder"] = true,
			["Broken Whale Statue"] = true,
			["Brownell's Blue Striped Racer"] = true,
			["Captain Rumsey's Lager"] = true,
			["Carved Wooden Helm"] = true,
			["Chipped Hair Brush"] = true,
			["Chromie's Gold Coin"] = true,
			["Chuck's Bucket"] = true,
			["Coldriver Carp"] = true,
			["Corpse Worm"] = true,
			["Corpse-Fed Pike"] = true,
			["Corroded Jewelry"] = true,
			["Corrupted Globule"] = true,
			["Crafted Star"] = true,
			["Crispy Dojani Eel"] = true,
			["Crystal Bass"] = true,
			["Curious Crate"] = true,
			["Cuttlefish Scale Breastplate"] = true,
			["Cuttlefish Tooth Ringmail"] = true,
			["Damp Diary Page (Day 4)"] = true,
			["Damp Diary Page (Day 87)"] = true,
			["Damp Diary Page (Day 512)"] = true,
			["Darkmoon Firewater"] = true,
			["Darkmoon Healing Tonic"] = true,
			["Darkwater Potion"] = true,
			["Day-Old Darkmoon Doughnut"] = true,
			["Dazzling Sapphire Pendant"] = true,
			["Decayed Treasure Map"] = true,
			["Decayed Whale Blubber"] = true,
			["Defender's Shadow Crystal"] = true,
			["Delicate Stormjewel"] = true,
			["Demon Noggin"] = true,
			["Demonic Detritus"] = true,
			["Dented Crate"] = true,
			["Desecrated Seaweed"] = true,
			["Design: Defender's Shadow Crystal"] = true,
			["Design: Purified Shadow Crystal"] = true,
			["Dezian Queenfish"] = true,
			["Diamond-Tipped Cane"] = true,
			["Digsong's Fish and Tips"] = true,
			["Disgusting Ooze"] = true,
			["Dog's Whistle"] = true,
			["Dojani Eel"] = true,
			["Draenic Water Walking Elixir"] = true,
			["Drowned Mana"] = true,
			["Drowned Thistleleaf"] = true,
			["Drowned Thunder Lizard Tail"] = true,
			["Elixir of Water Walking"] = true,
			["Emblem of Margoss"] = true,
			["Empty Snail Shell"] = true,
			["Enchanted Lure"] = true,
			["Eye of the Sea"] = true,
			["Face of the Forest"] = true,
			["Faded Treasure Map"] = true,
			["Faintly Pulsing Felstone"] = true,
			["Fat Sleeper Bait"] = true,
			["Fat Sleeper Egg"] = true,
			["Fat Sleeper Lunker"] = true,
			["Feathered Lure"] = true,
			["Felmouth Frenzy Bait"] = true,
			["Fishliver Oil"] = true,
			["Fire Ammonite Bait"] = true,
			["Fire Ammonite Lunker"] = true,
			["Fish Bladder"] = true,
			["Fish Cleaver"] = true,
			["Fish Hat"] = true,
			["Fish Tales"] = true,
			["Fishy"] = true,
			["Flesh Eating Worm"] = true,
			["Floating Totem"] = true,
			["Flying Tiger Gourami"] = true,
			["Fragmented Enchantment"] = true,
			["\"Fragrant\" Pheromone Fish"] = true,
			["Freshly-Speared Emperor Salmon"] = true,
			["Frogsticker Spearhead"] = true,
			["Frost Worm"] = true,
			["Frostdeep Minnow"] = true,
			["Funky Rotten Fish"] = true,
			["Funky Sea Snail"] = true,
			["Ghostly Queenfish"] = true,
			["Giant Catfish"] = true,
			["Giant Darkwater Clam"] = true,
			["Giant Flesh-Eating Tadpole"] = true,
			["Giant Freshwater Shrimp"] = true,
			["Giant Furious Pike"] = true,
			["Giant Sewer Rat"] = true,
			["Giant Catfish"] = true,
			["Gigantic Catfish"] = true,
			["Globe of Really Sticky Glue"] = true,
			["Glow Worm"] = true,
			["Glowing Fish Scale"] = true,
			["Gnomish Bait-o-Matic"] = true,
			["Golden Minnow"] = true,
			["Golden Stonefish"] = true,
			["Graybelly Lobster"] = true,
			["Great Sea Herring"] = true,
			["Grieferfish"] = true,
			["Grimnur's Bait"] = true,
			["Gub's Catch"] = true,
			["Hangman's Noose"] = true,
			["Hardened Walleye"] = true,
			["Hatecoil Spearhead"] = true,
			["Heavy Crate"] = true,
			["Heavy Supply Crate"] = true,
			["Heat-Treated Spinning Lure"] = true,
			["Hook Disgorger"] = true,
			["Hypermagnetic Lure"] = true,
			["Icespine Stinger"] = true,
			["Icespine Stinger Bait"] = true,
			["Iron Bound Trunk"] = true,
			["Ironbound Locked Chest"] = true,
			["Ivory-Reinforced Chestguard"] = true,
			["Jagged Abalone Meat"] = true,
			["Jawless Skulker Bait"] = true,
			["Jawless Skulker Egg"] = true,
			["Jawless Skulker Lunker"] = true,
			["Kaldorei Herring"] = true,
			["Kaskala Supplies"] = true,
			["Keefer's Angelfish"] = true,
			["Kel'Thuzad's Gold Coin"] = true,
			["Krasarang Fritters"] = true,
			["Lady Jaina Proudmoore's Gold Coin"] = true,
			["Lady Katrana Prestor's Gold Coin"] = true,
			["Land Shark"] = true,
			["Leyshimmer Blenny"] = true,
			["Luminous Bluetail"] = true,
			["Luminous Pearl"] = true,
			["Lunarfall Carp"] = true,
			["Lure Master Tackle Box"] = true,
			["Magic-Eater Frog"] = true,
			["Magical Crawdad Box"] = true,
			["Mark of Aquaos"] = true,
			["Message in a Beer Bottle"] = true,
			["Message in a Bottle"] = true,
			["Micro-Vortex Generator"] = true,
			["Midnight Salmon"] = true,
			["Mimic Octopus"] = true,
			["Mist-Hopper Emergency Buoy"] = true,
			["Misty Reed Mahi Mahi"] = true,
			["Mithril Bound Trunk"] = true,
			["Moat Monster Feeding Kit"] = true,
			["Molten Catfish"] = true,
			["Monstrous Clam Meat"] = true,
			["Monstrous Felblood Snapper"] = true,
			["Moonshell Claw"] = true,
			["Moonshell Claw Bait"] = true,
			["Moosebone Fish-Hook"] = true,
			["Mountain Puffer"] = true,
			["Mr. Pinchy"] = true,
			["Mr. Pinchy's Gift"] = true,
			["Muckbreath's Bucket"] = true,
			["Mudskunk Lure"] = true,
			["Nar'thalas Hermit"] = true,
			["Nat's Hookshot"] = true,
			["Nat's Lucky Coin"] = true,
			["Nat's Measuring Tape"] = true,
			["New Age Painting"] = true,
			["Nightcrawlers"] = true,
			["Nightmare Nightcrawler"] = true,
			["Nurtured Penguin Egg"] = true,
			["Oil Covered Fish"] = true,
			["Old \"Pirate\" Map"] = true,
			["Old Teamster's Skull"] = true,
			["Oodelfjisk"] = true,
			["Overgrown Earthworm"] = true,
			["Pagle's Fish Paste, Extra Strength"] = true,
			["Pale Ghoulfish"] = true,
			["Parasitic Starfish"] = true,
			["Partially Eaten Fish"] = true,
			["Pattern: Emerald Bag"] = true,
			["Pattern: Trapper's Traveling Pack"] = true,
			["Pearlescent Conch"] = true,
			["Phantom Ghostfish"] = true,
			["Pigment-Stained Robes"] = true,
			["Plated Armorfish"] = true,
			["Polished Skull"] = true,
			["Porcelain Bell"] = true,
			["Poshken's Ring"] = true,
			["Precious Locket"] = true,
			["Prickly Puffer Spine"] = true,
			["Prince Kael'thas Sunstrider's Gold Coin"] = true,
			["Pristine Crane Egg"] = true,
			["Pristine Moosebone Fish-Hook"] = true,
			["Pristine Shimmerscale Eel"] = true,
			["Purified Shadow Crystal"] = true,
			["Randy Smallfish"] = true,
			["Rat Trap"] = true,
			["Ravenous Fly"] = true,
			["Razgar's Fillet Knife"] = true,
			["Recipe: Broiled Bloodfin"] = true,
			["Recipe: Captain Rumsey's Lager"] = true,
			["Recipe: Fancy Darkmoon Feast"] = true,
			["Recipe: Krasarang Fritters"] = true,
			["Recipe: Lemon Herb Fillet"] = true,
			["Recipe: Skullfish Soup"] = true,
			["Recipe: Sugar-Crusted Fish Feast"] = true,
			["Recipe: Viseclaw Soup"] = true,
			["Red Snapper"] = true,
			["Reinforced Crate"] = true,
			["Reinforced Locked Chest"] = true,
			["Reins of the Azure Water Strider"] = true,
			["Reins of the Crimson Water Strider"] = true,
			["Replica Gondola"] = true,
			["Reptile Egg"] = true,
			["Riding Turtle"] = true,
			["Rigid Stormjewel"] = true,
			["Rock Lobster"] = true,
			["Rook's Lucky Fishin' Line"] = true,
			["Rotten Fishbone"] = true,
			["Royal Monkfish"] = true,
			["Ruined Pattern"] = true,
			["Rusty Prison Key"] = true,
			["Rusty Queenfish Brooch"] = true,
			["Rusty Shipwreck Debris"] = true,
			["Sack of Starfish"] = true,
			["Salmon Lure"] = true,
			["Sandy Carp"] = true,
			["Sar'theris Striker"] = true,
			["Savage Coast Blue Sailfin"] = true,
			["Sea Calf"] = true,
			["Sea Scorpion Bait"] = true,
			["Sea Pony"] = true,
			["Sea Turtle"] = true,
			["Seabottom Squid"] = true,
			["Seafarer's Slidewhistle"] = true,
			["Sealed Charter Tube"] = true,
			["Sealed Crate"] = true,
			["Sealed Darkmoon Crate"] = true,
			["Sealed Vial of Poison"] = true,
			["Seerspine Puffer"] = true,
			["Severed Abomination Head"] = true,
			["Severed Arm"] = true,
			["Shadow Sturgeon"] = true,
			["Sharpened Fish Hook"] = true,
			["Shiny Bauble"] = true,
			["Shiny Stone"] = true,
			["Silas' Secret Stash"] = true,
			["Silver Goby"] = true,
			["Skrog Toenail"] = true,
			["Sleeping Murloc"] = true,
			["Slippery Eel"] = true,
			["Small Chest"] = true,
			["Small Locked Chest"] = true,
			["Snapclaw's Claw"] = true,
			["Snarly's Bucket"] = true,
			["Snowfall Glade Pup"] = true,
			["Solid Gold Coin"] = true,
			["Solid Stormjewel"] = true,
			["Sparkling Stormjewel"] = true,
			["Speckled Tastyfish"] = true,
			["Spinefish Alpha"] = true,
			["Squirming Slime Mold"] = true,
			["Stag Eye"] = true,
			["Starfish on a String"] = true,
			["Stendel's Bane"] = true,
			["Sting Ray Pup"] = true,
			["Stinger"] = true,
			["Stinky Fish Head"] = true,
			["Stocking Up"] = true,
			["Stolen Fish"] = true,
			["Stonebull Crayfish"] = true,
			["Strand Crawler"] = true,
			["Strange Engine Part"] = true,
			["String of Alligator Teeth"] = true,
			["Stripped Drilling Gears"] = true,
			["Stuffed Shark Head"] = true,
			["Stunned, Angry Shark"] = true,
			["Sturdy Locked Chest"] = true,
			["Suncrawler"] = true,
			["Swatch of Netting"] = true,
			["Swollen Murloc Egg"] = true,
			["Sylvanas Windrunner's Gold Coin"] = true,
			["Tainted Runescale Koi"] = true,
			["Tangled Bronze Hooks"] = true,
			["Tasty Reef Fish"] = true,
			["Teldrassil Clam"] = true,
			["Teron's Gold Coin"] = true,
			["Terrorfin"] = true,
			["Terrorfish"] = true,
			["The Sister's Pendant"] = true,
			["Thorned Flounder"] = true,
			["Thundering Stormray"] = true,
			["Thrall's Gold Coin"] = true,
			["Thresher Teeth"] = true,
			["Throwing Starfish"] = true,
			["Tightly Sealed Trunk"] = true,
			["Tiny Blue Carp"] = true,
			["Tiny Goldfish"] = true,
			["Tiny Green Carp"] = true,
			["Tiny Little Grabbing Apparatus"] = true,
			["Tiny Red Carp"] = true,
			["Tiny Titanium Lockbox"] = true,
			["Tiny White Carp"] = true,
			["Tirion Fordring's Gold Coin"] = true,
			["Toothy's Bucket"] = true,
			["Totemic Purification Rod"] = true,
			["Tower Key"] = true,
			["Toxic Puddlefish"] = true,
			["Traditional Flensing Knife"] = true,
			["Translucent Shell"] = true,
			["Trapper's Traveling Pack"] = true,
			["Trashy"] = true,
			["Turtle-Minders Robe"] = true,
			["Tyfish"] = true,
			["Undelivered Love Letter"] = true,
			["Unusual Compass"] = true,
			["Uther Lightbringer's Gold Coin"] = true,
			["Velociraptor Skull"] = true,
			["Very Unlucky Rock"] = true,
			["Vicious Ancient Fish"] = true,
			["Violet Perch"] = true,
			["Viseclaw Fisher Eye"] = true,
			["Viseclaw Soup"] = true,
			["Water Stone"] = true,
			["Water Totem Figurine"] = true,
			["Waterlogged Crate"] = true,
			["Waterlogged Recipe"] = true,
			["Watertight Trunk"] = true,
			["Weather-Beaten Journal"] = true,
			["Whale Statue"] = true,
			["Whale-Skin Breastplate"] = true,
			["Whale-Skin Vest"] = true,
			["Whale-Stick Harpoon"] = true,
			["Whalebone Carapace"] = true,
			["White Sparkly Bauble"] = true,
			["Wish Crystal"] = true,
			["Wolf Piranha	"] = true,
			["World's Largest Mudfish"] = true,
			["Worm Supreme"] = true,
			["Young Ironjaw"] = true,
			["Zangar Eel"] = true,
			["Zulian Mudskunk"] = true,
}

local fishingNPCs = {
			["Adam"] = true,
			["Akule Riverhorn"] = true,
			["Ancient Vrykul Spirit"] = true,			
			["Art Hughie"] = true,
			["Attracted Reef Bull"] = true,
			["Austin Windmill"] = true,
			["Azure Water Strider"] = true,
			["Bart Tidewater"] = true,
			["Benevolent Mr. Pinchy"] = true,
			["Billy"] = true,
			["Blorp"] = true,
			["Blythe"] = true,
			["Brandon"] = true,
			["Bry Lang"] = true,
			["Canal Crab"] = true,
			["Christopher Sloan"] = true,
			["Chuck"] = true,
			["Colton Smith"] = true,
			["Conjuror Margoss"] = true,
			["Corbyn"] = true,
			["Costumed Entertainer"] = true,
			["Coxswain Hook"] = true,
			["Crawler"] = true,
			["Crayfish Catch Credit"] = true,
			["Crimson Water Strider"] = true,
			["Dankin Farsnipe"] = true,
			["Dead Fish"] = true,
			["Drogan Ironshaper"] = true,
			["Elder Clearwater"] = true,
			["Elder Kesmet"] = true,
			["Emerald Bag"] = true,
			["Enormous Globule"] = true,
			["Eventide Villager"] = true,
			["Fenwick Thatros"] = true,
			["Fish Felreed"] = true,
			["Fishbot 5000"] = true,
			["Fishy"] = true,
			["Frenzied Reef Shark"] = true,
			["Frostdeep Cavedweller"] = true,
			["Furious Mr. Pinchy"] = true,
			["Ghostshell Crab"] = true,
			["Giant Sewer Rat"] = true,
			["Gogo"] = true,
			["Golden Stonefish"] = true,
			["Gorkas"] = true,
			["Grant"] = true,
			["Gubb"] = true,
			["Hal McAllister"] = true,
			["Half-Eaten Fish"] = true,
			["Harklane"] = true,
			["High Admiral \"Shelly\" Jorrik"] = true,
			["Harold"] = true,
			["Hatecoil Spirit"] = true,
			["Hungry Tuskarr"] = true,
			["Ilyssia of the Waters"] = true,
			["Impus"] = true,
			["Islen Waterseer"] = true,
			["Ivan Walkers"] = true,
			["Jacob Anders"] = true,
			["Jamin"] = true,
			["Jang"] = true,
			["Jeigh Southie"] = true,
			["Jeorge Swiftbrook"] = true,
			["Jinar'Zillen"] = true,
			["Jock Lindsey"] = true,
			["Jorgen"] = true,
			["Justin"] = true,
			["Kalo"] = true,
			["Keeper Raynae"] = true,
			["Kill Credit: Fishery"] = true,
			["Killian Sanatha"] = true,
			["Klixx"] = true,
			["Kriggon Talsone"] = true,
			["Kubb"] = true,
			["Laird"] = true,
			["Land Shark"] = true,
			["Landlocked Shark"] = true,
			["Leviathan Weak Point A"] = true,
			["Leviathan Weak Point B"] = true,
			["Leviathan Weak Point C"] = true,
			["Leviathan Weak Point D"] = true,
			["Lunarfall Cavedweller"] = true,
			["Madari"] = true,
			["Magical Crawdad"] = true,
			["Magicus"] = true,
			["Mahren Skyseer"] = true,
			["Maiden's Virtue crewman"] = true,
			["Marri"] = true,
			["Master Gunner Line"] = true,
			["Master Lo"] = true,
			["Matheis"] = true,
			["Matt"] = true,
			["Mglrrp"] = true,
			["Moat Monster"] = true,
			["Mokugg Lagerpounder"] = true,
			["Muckbreath"] = true,
			["Nandaez"] = true,
			["Narjon the Gulper"] = true,
			["Nida"] = true,
			["Pengu"] = true,
			["Pierre Fishflay"] = true,
			["Potion of Mazu's Breath"] = true,
			["Prickly Puffer"] = true,
			["Rai"] = true,
			["Razgar"] = true,
			["Red Jack Flint"] = true,
			["Reef Bull"] = true,
			["Reef Cow"] = true,
			["Riggle Bassbait"] = true,
			["Roger"] = true,
			["Rok'kal"] = true,
			["Roman"] = true,
			["Rotten Fishbone"] = true,
			["School of Fish"] = true,
			["Sea Calf"] = true,
			["Sea Pony"] = true,
			["Sea Turtle"] = true,
			["Sebastian Bower"] = true,
			["Seehmo"] = true,
			["Seth"] = true,
			["Sha'leth"] = true,
			["Shadowy Fish"] = true,
			["Shawn"] = true,
			["\"Sinker\""] = true,
			["Snarly"] = true,
			["Snowfall Glade Pup"] = true,
			["Stephanie Sindree"] = true,
			["Sting Ray"] = true,
			["Strand Crawler"] = true,
			["Summon Tuskarr Spear"] = true,
			["Surly Fishflayer"] = true,
			["Swift"] = true,
			["Talaelar"] = true,
			["Tanji the Fisher"] = true,
			["Tarn Riverhorn"] = true,
			["Teleportologist Fozlebub"] = true,
			["Tharis Strongcast"] = true,
			["The Talking Fish"] = true,
			["Thelia Garron"] = true,
			["Thorina"] = true,
			["Thresher Deckhand"] = true,
			["Tiny Blue Carp"] = true,
			["Tiny Goldfish"] = true,
			["Tiny Green Carp"] = true,
			["Tiny Red Carp"] = true,
			["Tiny White Carp"] = true,
			["Toothy"] = true,
			["Torgo the Younger"] = true,
			["Trashy"] = true,
			["Treasure Hunter"] = true,
			["Unlucky Fish"] = true,
			["Wavesinger Zara"] = true,
			["Wigcik"] = true,
			["Witherbark Fisher"] = true,
			["Young Ironjaw Credit"] = true,
			["Zem Leeward"] = true,
}

local fishingSpells = {
			["8087"] = true,	-- Shiny Bauble
			["8088"] = true,	-- Nightcrawlers
			["8089"] = true,	-- Aquadynamic Fish Attractor
			["8090"] = true,	-- Bright Baubles
			["8532"] = true,	-- Aquadynamic Fish Lens
			["9092"] = true,	-- Flesh Eating Worm
			["11319"] = true,	-- Water Walking
			["30174"] = true,	-- Riding Turtle (Summon Mount)
			["33050"] = true,	-- Magical Crawdad (Summon Pet)
			["33064"] = true,	-- Mr. Pinchy's Gift
			["43308"] = true,	-- Find Fish
			["43761"] = true,	-- Broiled Bloodfin
			["43697"] = true,	-- Toothy (Summon Pet)
			["43698"] = true,	-- Muckbreath (Summon Pet)
			["44454"] = true,	-- Tasty Reef Fish
			["45694"] = true,	-- Captain Rumsey's Lager
			["45695"] = true,	-- Captain Rumsey's Lager
			["45731"] = true,	-- Sharpened Fish Hook
			["46425"] = true,	-- Snarly (Summon Pet)
			["46426"] = true,	-- Chuck (Summon Pet)
			["48794"] = true,	-- Cast Net
			["50970"] = true,	-- Trapper's Traveling Pack
			["53869"] = true,	-- Defender's Shadow Crystal
			["53921"] = true,	-- Purified Shadow Crystal
			["59125"] = true,	-- Lucky
			["59250"] = true,	-- Giant Sewer Rat
			["59645"] = true,	-- Underbelly Elixir
			["60871"] = true,	-- Fireblast
			["61357"] = true,	-- Pengu (Summon Pet)
			["62410"] = true,	-- Elixir of Water Walking
			["62561"] = true,	-- Strand Crawler (Summon Pet)
			["63924"] = true,	-- Emerald Bag
			["64385"] = true,	-- Spinning (Unusual Compass)
			["64401"] = true,	-- Glow Worm
			["64731"] = true,	-- Sea Turtle (Summon Mount)
			["80610"] = true,	-- Water Gliding
			["80832"] = true,	-- Viseclaw Fisher Eye
			["80868"] = true,	-- Stag Eye Bait
			["87646"] = true,	-- Feathered Lure
			["93395"] = true,	-- Water Walking
			["95244"] = true,	-- Heat-Treated Spinning Lure
			["99315"] = true,	-- Corpse Worm Bait
			["99328"] = true,	-- Time for Slime: Create Slime Mold
			["99334"] = true,	-- Fillet Giant Catfish
			["99339"] = true,	-- Pickup Baby Octopus
			["99340"] = true,	-- Pickup Baby Octopus
			["99424"] = true,	-- Crayfish Catch
			["99429"] = true,	-- Display Young Ironjaw
			["99431"] = true,	-- Feed Squirky
			["99435"] = true,	-- Grimnur's Bait
			["99451"] = true,	-- Cancel Crayfish Catch
			["99473"] = true,	-- Craving Crayfish: Create Stonebull Crayfish
			["99474"] = true,	-- Create Gnomish Bait-o-Matic
			["99508"] = true,	-- Throw Frog
			["99511"] = true,	-- Simulate Alliance Presence
			["99524"] = true,	-- [DND] Give Frog
			["99525"] = true,	-- [DND] Give Decoy Kit
			["101498"] = true,	-- Throwing Starfish
			["101500"] = true,	-- Create Throwing Starfish
			["103588"] = true,	-- Darkwater Potion
			["105707"] = true,	-- Darkwater Potion
			["109244"] = true,	-- Back to the Cannon!
			["115369"] = true,	-- Spear Fish
			["118089"] = true,	-- Azure Water Strider (Summon Mount)
			["122748"] = true,	-- Fishy (Summon Pet)
			["123803"] = true,	-- Fed
			["124000"] = true,	-- Tiny Goldfish (Summon Pet)
			["124029"] = true,	-- Viseclaw Soup
			["124032"] = true,	-- Krasarang Fritters
			["124657"] = true,	-- Potion of Mazu's Breath
			["124927"] = true,	-- Call Dog
			["124960"] = true,	-- Mist-Hopper Emergency Buoy
			["127271"] = true,	-- Crimson Water Strider (Summon Mount)
			["127285"] = true,	-- Shimmering Water
			["128357"] = true,	-- Sharpened Tuskarr Spear
			["139361"] = true,	-- Tiny Red Carp (Summon Pet)
			["139362"] = true,	-- Tiny Blue Carp (Summon Pet)
			["139363"] = true,	-- Tiny Green Carp (Summon Pet)
			["139365"] = true,	-- Tiny White Carp (Summon Pet)
			["152421"] = true,	-- Bipsi's Bobbing Berg
			["158031"] = true,	-- Jawless Skulker Bait
			["158034"] = true,	-- Fat Sleeper Bait
			["158035"] = true,	-- Blind Lake Sturgeon Bait
			["158036"] = true,	-- Fire Ammonite Bait
			["158037"] = true,	-- Sea Scorpion Bait
			["158038"] = true,	-- Abyssal Gulper Eel Bait
			["158039"] = true,	-- Blackwater Whiptail Bait
			["158693"] = true,	-- Fish Pheromones
			["168448"] = true,	-- Icespine Stinger Bait
			["168868"] = true,	-- Moonshell Claw Bait
			["168977"] = true,	-- Sea Calf (Summon Pet)
			["171740"] = true,	-- Nat's Hookshot Bait
			["171741"] = true,	-- Cancel Hookshot Bait Aura
			["172694"] = true,	-- Reading
			["172695"] = true,	-- Land Shark (Summon Pet)
			["174471"] = true,	-- Worm Supreme
			["174524"] = true,	-- Awesome!
			["174528"] = true,	-- Griefer
			["174841"] = true,	-- Thank you!
			["175841"] = true,	-- Draenic Water Walking
			["182226"] = true,	-- Bladebone Hook
			["185490"] = true,	-- Darkmoon Healing Tonic
			["185587"] = true,	-- Day-Old Darkmoon Doughnut
			["185591"] = true,	-- Ghostshell Crab (Summon Pet)
			["185601"] = true,	-- Blorp (Summon Pet)
			["185712"] = true,	-- Seafarer's Slidewhistle
			["188512"] = true,	-- Fel Lash
			["188904"] = true,	-- Felmouth Frenzy Bait
			["201808"] = true,	-- Rotten Fishbone
			["201824"] = true,	-- Stunned, Angry Shark
			["202082"] = true,	-- Rotten Fishbone
			["221477"] = true,	-- Underlight
			["239673"] = true,	-- Something's Fishy
			["240801"] = true,	-- Demon Noggin
			["240802"] = true,	-- Floating Totem
			["240803"] = true,	-- Carved Wooden Helm
			["240804"] = true,	-- Replica Gondola
			["240806"] = true,	-- Face of the Forest
}
local fishingSpellsReverse = {}
for k,v in pairs( fishingSpells ) do
	fishingSpellsReverse[v] = k
end

-- "Angler" results in one false positive for the rare elite "Lord Angler" NPC. No problem for quest titles

local fishingText = { "Angler", "Bobber", "Fisherman", "Fishing", "Fishmonger", "Kalu'ak", "Nat Pagle", }

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Fishing Puns and Yells
--		======================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local puns = {  
		"My wife said to me that\nif I go fishing once more\nshe will leave me...\n\nGod I will miss her", "This scampi happening!",
		"\"So a fish walked into\na bar and said...\"\n\n\"Aw, don't be silly,\nfish can't talk\"", "Waiting with baited breath...",
		"Yes officer, I got me a licence.\nIt's for two days and I only\nused it once last week", "Goby with your\nfriends then...",
		"Is it dangerous to swim\non a full stomach?\n\nYes. It's better to swim\nin the water", "Why do clownfish taste so funny?",
		"Why are some fish at\nthe bottom of the ocean?\n\nBecause they dropped\nout of school", "So, fish bath in\na river basin?",
		"Did you hear about the fight\nat the seafood restaurant?\n\nFour fish got battered!", "Allah us wanna go\nfishing, wudhu?",
		"Teach a man to fish\nand he will sit in a\nboat all day and be\nlate for dinner...", "Don't carp on about it,\nplease %p!",
		"Why is a fishmonger\nnever generous?\n\nBecause his business\nmakes him shell-fish", "The early worm\ncatches the fish...",
		"What did the Atlantic Ocean\nsay to the Pacific Ocean?\n\nNothing, it just waved", "Fish that swim in\nschools are smart!",
		"Oh cod, I can't\ntake any more of\nthese fishy puns...\n\nI'm outta this plaice", "What you say is a\nload of scallops...",
		"Hmmm... not enough bass", "Oh, so you are supposed to\nwear a leather jacket...", "Were you expecting\njust a sole reply?",
		"What do you call a shark\nwith a rocket launcher?\n\nAnything it tells you to", "Where do fish sleep?\n\nIn the river bed",
		"What should you do if you\nfind a shark in your bed?\n\nSleep somewhere else", "I think the waiter sprat\nin your soup...",
		"I don't always make fish puns.\nBut when I do,...\nI do it for the halibut!", "Don't trout yourself!\nAny fin is possible",
		"Why did the plaice\ngo to the doctor?\n\nBecause he was\nfeeling a bit flat", "Football is a game\nbut fishing is serious",
		"What should you do if you\nfind a shark in your bed?\n\nSleep elsewhere...", "Question %p, do fish\nsleep in a river bed?",
		"What do you call a shark\nwith a machine gun?\n\nAnything he tells you to", "Where is a fish in orbit?\n\Trouter space...",
		"What happens to\nsleepy fish at the\nedge of a reef?\n\nThey drop off", "What do you call a\nshark with a gun?\n\n\"Sir\"",
		"Why did the fish\ncross the road?\n\nBecause the chicken\nwas on holidays", "Do you catch a Left Shark\nwith a left hook?",
		"What do you call\na deaf pike?\n\nAnything you like,\nhe cannot hear you", "Had a girlfriend, I lobster.\nThen I flounder",
		"Why are fish so gullible?\nThey fall for things\nhook, line and sinker!", "Work is for people who\ndon't know how to fish",
		"What do you call a\ndeaf great white shark?\n\nAnything you like...", "Old fishermen never die.\nThey just smell that way",
		"Why did the fish\ncross the road?\n\nIt was the chicken’s day off", "What kind of fish does\na parrot sit on?\n\nA perch!",
		"Do fish go home and brag\nabout the size of the bait\nthey stole?", "There's definitely something\nfishy here offisher...",
		"We're a fair way out...\nyou got enough fuel?\n\nI think so...", "What fish goes up the\nriver at 100mph?\n\nA motor-pike",		
		"What did the mermaid wear\nto maths class?\n\nHer algae-bra...", "When fish go into business\nthey start on a small scale",
		"Floundering about\nagain %p?", "Can we eel our\nrelationship?", "What kind of fish is made\nof two sodium atoms?\n\n2 na!", 
		"Early to bed,\nEarly to rise,\nFish all day,\nTell big lies", "Where did Noah keep the fish?\n\nIn a multi-level carp ark",
		"Seal 1: So this fish said to...\n\nSeal 2: Aww, don't be sealy,\nfish can't talk!", "I reely feel gillty", "DND: Fishing!",
		"I spent most of my\nmoney on fishing.\nThe rest I wasted", "I smell something fishy\naround here...", "You sealy doofish!",
		"What side of a fish\nhas the most scales?\n\nThe outside", "How do you\npost a fish?\n\nSend it COD", "AFK: Gone fishing!",
		"You okay %p? You seem\nto be floundering...", "Pollocks to you,\nyou basstard!", "I used to do that\nwhen I first started",
		"You should spend a few\nsquid on a new fishing hat", "Don't make the same\nmis-hake %p!", "I thought YOU put the plug in?",
		"Are you the new squid\non the block?", "Hmmm, your fishing\ngear should really\nscale well %p...", "Just one more cast...",
		"Wasn't your rod in the\nrod holder just now?", "I thought YOU were\ngoing to bring the bait!", "You're kraken me up %p...",
 		"So I said to Nemo\n\"Don't be a clown...\"", "Careful, you'll pull a\nmussel doing that!", "Oops, my fly has\ncome undone",
		"There I was, pole in hand\nwith fishnets and eels on...", "Ah, sole is over there!", "Not tonight, I've\ngot a haddock...",
		"It is not the rod in the hand,\nbut the hand on the rod", "Time to scale back\non the fish puns", "It tugs on your fly...",
		"How do you communicate\nwith a fish?\n\nDrop it a line", "Good things come to\nthose that bait", "Any fin could happen...",
		"How can a fish\ncross the road?\n\nTie it to a chicken", "This plaice is great\nfor fishin'...", "Goin' in for the krill?",
		"Aww, the cute little fish\nare going to plaice school", "Don't drink from\nthe chum bucket!", "So saury, so very saury...",
		"Where do fish\nkeep their money?\n\nIn the river bank", "Uhoh... the fuel gauge is stuck...", "Thanks for all the fish...",
		"Did you just\nwee in the water?\n\nNo, the sea weed", "They always bite better\nyesterday", "Not bad, cod do batter %p...",
		"Hooked on fishin'!", "Who let you off the hook?", "Exactly how do\nyou jump a shark?", "So I guess you are\noff the hook?",
		"What do you use\nto cut the ocean?\n\nA sea-saw", "Can you sing without\nan autotuna?", "Oh cod, you are\nso shellfish...",
		"Hey, that lure I bought\ndidn't have a bar cod!", "Did you fart?\nBecause that sure smelt?", "One more and we'll have one",
		"Next time you're in Shatt,\ndrop me a line!", "At least it was a nice day on the water...", "Hey, where did my bobber go?",
		"Don't trout yourself!\nAny fin is possible!", "Stuck between a rock\nand a hard plaice...", "Let's not shark the issue...",
		"Reely? That's not what\nI've been herring!", "Well, just for the halibut of course...", "But what about the\nRight Shark?",		
		"Why did the fish\nswim to the river bank?\n\nBecause it couldn't walk", "Thank Cod it's Friday...", "That's eely nice %p!",
		"After a hard days fishing,\nthere's nothing like a\nglass of bitterling!", "Here's looking at\nyou, squid", "Carp diem...",
		"Keep friends close,\nanemones closer!", "Aw, c'mon %p,\ndon't be shellfish!", "I'm herring you %p...", "Don't be koi now!",
		"Fishing any day,\nbarramundi", "You seen my guitar tuna?", "So how do you tuna fish?", "Let minnow %p...", "Learn to sea!",
		"Murloc gear scales well!", "Why is your line slack?", "What a roeful idea...", "Just krilling time...", "That's no fluke!",
		"Yes officer, i do have a\nlot of fish but they don't\ncount against my limit as\nthey are very small...", "Seas the day!",
		"What is dry on the outside,\nfilled with water and\nblows up buildings?\n\nA fish tank", "Mullet over %p, mullet over...",
		"Whale, I best be off.\nIf you sea a friend,\ndon't forget to wave", "We all just need\nto clam down!", "Reely %p, reely?",
		"Ease up on the puns\nand keep it reel", "You are one bad\nmother puffer!", "Man I Love Fishing!", "You somebody's beach?", 
		"Make your own fish pun!\nDon't leave it to salmon else!", "Try salmon else %p...", "Good things come to\nthose who bait", 
		"You got anything to plug\nthis hole here?", "I'd rather be lucky than good!", "R.I.P. Laird!",
}
local numPuns = 156

--------------------------------------------------------------------------------------------------------------------------------------------

local punsLoving = { "Whale you be mine?", "You're my sole mate...", "We were manta be together", "My plaice or yours?", "Let's cuttle...",
		"Why be anemones when we could be special fronds?", "For my dar-Ling", "50 Shades of Greyling", "I caught you babe!",
		"You are my heart and sole", "You're a great catch %p", "I'm hooked on you!", "Let's hook up!",
		"Salmon-chanted evening with you", "It's o-fish-al!\nI want YOU to be\nmy valentine!", }
local numPunsLoving = 15

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Colour Printing - Chocolate theme
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local pc_colour_Prefix		= "\124cFFD2691E"	-- X11Chocolate
local pc_colour_Highlight	= "\124cFFF4A460"	-- X11SandyBrown
local pc_colour_PlainText	= "\124cFFDEB887"	-- X11BurlyWood

local function printPC( message )
	if message then
		DEFAULT_CHAT_FRAME:AddMessage( pc_colour_Prefix.. ( addonTitle or addonName ).. ": ".. pc_colour_PlainText.. message.. "\124r" )
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Add Pun / Yell
--		==============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local savedKey, savedPun, savedPunID, previousKeys = "", "", 0, {}

local function AddLine( entityType, id, passedTooltip )

	if not id then return end
	if not ( ( type( id ) == "string" ) or ( type( id ) == "number" ) ) then return end
	
	local tooltip = passedTooltip or GameTooltip
			
	-- Keep showing the same pun until the Tooltip goes away
	if savedKey and ( savedKey == id ) then
		tooltip:AddLine( savedPun )
		tooltip:Show()
		return
	end

	local needPun = false

	-- If this entity has been used already then make sure it is not too soon Majordomo Executus!
	if previousKeys[ id ] then
		if ( ( previousKeys[ id ] + ScampiDB.delay ) > GetTime() ) then return end
		previousKeys[ id ] = GetTime()
		needPun = true
	else
		-- the passed ID (i.e. entity name) might flag a key word
		for _,v in ipairs( fishingText ) do
			if find( id, v, 1, booleanTrue ) then
				previousKeys[ id ] = GetTime()
				needPun = true
				break
			end
		end
	end
	
	if ( needPun == false ) and ( entityType == "NPC" ) then	-- Will always be GameTooltip
		local line, numLines = "", ( GameTooltip:NumLines() < 2 ) and GameTooltip:NumLines() or 2
		for i = 1, numLines do
			line = _G["GameTooltipTextLeft"..i ]:GetText()
			for _,v in ipairs( fishingText ) do
				if find( line, v, 1, booleanTrue ) then
					previousKeys[ id ] = GetTime()
					needPun = true
					break
				end
			end
		end
	end
	
	if ( needPun == false ) then
	
		-- Now check against the tables of spells/items/NPCs
		
		if ( entityType == "NPC" ) then
			if fishingNPCs[ id ] then
				previousKeys[ id ] = GetTime()
				needPun = true
			end
		elseif ( entityType == "item" ) then		
			if nonWearableFishing[ id ] then
				previousKeys[ id ] = GetTime()
				needPun = true
			elseif wearableFishing[ id ] then
				previousKeys[ id ] = GetTime()
				needPun = true
			end
		elseif ( entityType == "spell" ) then
			if fishingSpells[ id ] then
				previousKeys[ id ] = GetTime()
				needPun = true
			end
		elseif ( entityType == "SpellName" ) then
			if fishingSpellsReverse[ id ] then
				previousKeys[ id ] = GetTime()
				needPun = true
			end

		else printPC( "Bad boy entity:"..entityType.." (id="..(id or "nil")..")") return
		
		end
	end
	
	if ( needPun == false ) then
		savedKey = nil
		return 
	end

	local punID = savedPunID
	local tshMonth = tonumber(date("%m"))
	local tshDay = tonumber(date("%d"))
	if ( tshMonth == 2 ) and ( tshDay == 14 ) then
		while ( punID == savedPunID ) do
			punID = random( numPunsLoving )
		end
		savedKey, savedPunID = id, punID
		savedPun = spaceLine.. "\124cFF00B7EB".. punsLoving[ punID ]
	else
		while ( punID == savedPunID ) do
			punID = random( numPuns )
		end
		savedKey, savedPunID = id, punID
		savedPun = spaceLine.. "\124cFF00B7EB".. puns[ punID ]
	end
	
	savedPun = gsub( savedPun, "%%p", UnitName( "player" ) )
	
	tooltip:AddLine( savedPun )
	tooltip:Show()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		AddLine Feeders / Preliminary
--		=============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- 8.0.1

local function AddLine_ItemID( id )
	if id then
		local item = GetItemInfo( id )
		AddLine( "item", item ) 
	else
		-- Brute force. We just assume that the first line is the name of the entity (fair enough) and that it is an item (almost 100%)
		local name = GameTooltipTextLeft1:GetText()
		if name then AddLine( "item", name ) end
	end
end

local function AddLine_ItemLink( link )

	local label, id;
	-- It is possible (but rare) that the "item" link was actually a spell. This is why working with links is always preferred
	if link then
		_, _, label, id = find( link, "|H(%w+):(%d+)" )
		if not label then _, _, label, id = find( link, "(%w+):(%d+)" ) end
	elseif ( buildVersionMajor > "1" ) then
		local _, gottenLink = GameTooltip:GetItem()
		-- Has always returned name and link
		if gottenLink then _, _, label, id = find( gottenLink, "|H(%w+):(%d+)" ) end
	end
	if ( label == "item" ) then
		AddLine_ItemID( id )
	else
		AddLine( label, id )
	end
end

local function AddLine_Spell()

-- We haven't always had SpellIDs and GameTooltip:GetSpell() was introduced during WotLK
-- Extracting the first Tooltip line is less certain/reliable due to possible conflict with other AddOns

	if ( buildVersionMajor > "1" ) then
		local _, _, id = GameTooltip:GetSpell()		-- Added TBC 2.0.3
		if id then
			AddLine( "spell", tostring( id ) )
			return
		end
	end
	local name = GameTooltipTextLeft1:GetText()
	if name then AddLine( "SpellName", name ) end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Hooks
--		=====
--
--------------------------------------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------------------------------------
-- Chat linked References for anything supported by ItemRefTooltip:SetHyperlink()
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( ItemRefTooltip, "SetHyperlink", 
		function( self, link )
			local _, _, label, id = find( link, "|H(%w+):(%d+)" )
			AddLine_ItemLink( label, id, nil, ItemRefTooltip )
		end )
else
	original_ItemRefTooltip_SetHyperlink = ItemRefTooltip.SetHyperlink
	function ItemRefTooltip.SetHyperlink( this, link )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_ItemRefTooltip_SetHyperlink( this, link )
		local _, _, label, id = find( link, "|H(%w+):(%d+)" )
		if not label then _, _, label, id = find( link, "(%w+):(%d+)" ) end
		local item = GetItemInfo( id )
		AddLine( label, item, ItemRefTooltip )
		return r1, r2, r3, r4, r5, r6, r7, r8
 	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Action Bar Button
--------------------------------------------------------------------------------------------------------------------------------------------

-- In Vanilla at least, this "SetAction" widget gets invoked at the point where a DRAGGED item/spell is over an empty Action Bar button.
-- There will be NO GameTooltip and thus a GameTooltipTextLeft1:GetText() will return null

local function GetAction( slotID )
	local text = GetActionText( slotID )
	-- Expecting nil except if a macro ( and maybe something else a bit unusual ? )
	if not text then
		if ( buildVersionMajor > "1" ) then
			local label, id;
			local _, link = GameTooltip:GetItem()
			if link then
				AddLine_ItemLink( link )
			else
				_, _, id = GameTooltip:GetSpell()
				if id then
					AddLine( "spell", tostring( id ) )
				end
			end
			if not id then
				local name = GameTooltipTextLeft1:GetText()
				if name then AddLine( "spell", name ) end
			end
		else
			-- kind of stuck with Vanilla. No access to GetItem() nor GetSpell(). Only ONE Spellbook spell is relevant. That leaves
			-- items with a "use" component as perhaps relevant
			local name = GameTooltipTextLeft1:GetText()
			if name then AddLine( "item", name ) end
		end
	end
end

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetAction", function( self, slotID ) GetAction( slotID ) end )
else
	original_GameTooltip_SetAction = GameTooltip.SetAction
	function GameTooltip.SetAction( this, slotID )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetAction( this, slotID )
		GetAction( slotID )
		return r1, r2, r3, r4, r5, r6, r7, r8
 	end

end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Auctions: Items for sale, whether by the player or someone else
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetAuctionItem", 
		function( self, auctionType, index )
			local link = GetAuctionItemLink( auctionType, index )
			AddLine_ItemLink( link )
		end )
else
	original_GameTooltip_SetAuctionItem = GameTooltip.SetAuctionItem
	function GameTooltip.SetAuctionItem( this, auctionType, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetAuctionItem( this, auctionType, index )
		local link = GetAuctionItemLink( auctionType, index )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
 	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Auctions: Items being setup for sale and not yet posted for auction
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetAuctionSellItem", 
		function( self )

		end )
else
	original_GameTooltip_SetAuctionSellItem = GameTooltip.SetAuctionSellItem
	function GameTooltip.SetAuctionSellItem( this )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetAuctionSellItem( this )
		AddLine_ItemLink()
		return r1, r2, r3, r4, r5, r6, r7, r8
 	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Bank and Backpack Bags
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetBagItem", 
		function( self, bagID, slotID )
			local link = GetContainerItemLink( bagID, slotID )
			AddLine_ItemLink( link )
		end )
else
	original_GameTooltip_SetBagItem = GameTooltip.SetBagItem
	function GameTooltip.SetBagItem( this, bagID, slotID )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetBagItem( this, bagID, slotID )
		local link = GetContainerItemLink( bagID, slotID )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
 	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Guild Bank
--------------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

if ( buildVersionMajor > "2" ) or ( ( buildVersionMajor == "2" ) and ( buildVersionMinor > "2" ) ) then
	hooksecurefunc( GameTooltip, "SetGuildBankItem", 
		function( self, tabID, slotID )
			link = GetGuildBankItemLink( tabID, slotID )
			AddLine_ItemLink( link )
		end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Heirlooms of the Collections Frame
--------------------------------------------------------------------------------------------------------------------------------------------

-- New with WoD

if ( buildVersionMajor > "5" ) then
	hooksecurefunc( GameTooltip, "SetHeirloomByItemID", function( itemID ) AddLine_ItemID() end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Inventory Slots of "target" ( Player / Other Player ) / Bags ( as items themselves and NOT their contents )
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetInventoryItem", 
		function( self, unitID, slotID )
			local link = GetInventoryItemLink( unitID, slotID )
			AddLine_ItemLink( link )
		end )
else
	original_GameTooltip_SetInventoryItem = GameTooltip.SetInventoryItem
	function GameTooltip.SetInventoryItem( this, unitID, slotID )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetInventoryItem( this, unitID, slotID )
		local link = GetInventoryItemLink( unitID, slotID )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Item Upgrade
--------------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

if ( buildVersionMajor > "5" ) or ( ( buildVersionMajor == "5" ) and ( buildVersionMinor > "0" ) ) then
	hooksecurefunc( GameTooltip, "SetUpgradeItem", function( self ) AddLine_ItemID() end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Loot: Item
--------------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetLootItem", 
		function( self, index )
			local link = GetLootSlotLink( index )
			AddLine_ItemLink( link )
		end )
else
	local original_GameTooltip_SetLootItem = GameTooltip.SetLootItem
	function GameTooltip.SetLootItem( this, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetLootItem( this, index )
		local link = GetLootSlotLink( index )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Loot: Roll Item
--------------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetLootRollItem", function( self, index ) AddLine_ItemID() end )
else
	local original_GameTooltip_SetLootRollItem = GameTooltip.SetLootRollItem
	function GameTooltip.SetLootRollItem( this, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetLootRollItem( this, index )
		local link = GetLootRollItemLink( index )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Mail: Inbox & Open Attached Items (multiple/single)
--------------------------------------------------------------------------------------------------------------------------------------------

-- GetInboxItemLink(index) ADDED Patch 2.0.3?

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetInboxItem", function( self, index, attachIndex ) AddLine_ItemID() end )
else
	local original_GameTooltip_SetInboxItem = GameTooltip.SetInboxItem
	function GameTooltip.SetInboxItem( this, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetInboxItem( this, index )
		local link = GetInboxItemLink( index, attachIndex )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Mail: Send Attached Items
--------------------------------------------------------------------------------------------------------------------------------------------

-- GetSendMailItemLink added in TBC 2.1.0, Item IDs added in Legion 7.0.3

-- NEEDS TESTING

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetSendMailItem", function( self, index ) AddLine_ItemID() end )
else
	local original_GameTooltip_SetSendMailItem = GameTooltip.SetSendMailItem
	function GameTooltip.SetSendMailItem( this, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetSendMailItem( this, index )
		local name = GetSendMailItem( index )
		AddLine( "item", name )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Merchant: Buyback Item
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetBuybackItem", function( self, index ) AddLine_ItemID() end )
else
	local original_GameTooltip_SetBuybackItem = GameTooltip.SetBuybackItem
	function GameTooltip.SetBuybackItem( this, itemIndex )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetBuybackItem( this, itemIndex )
		local name = GetBuybackItemInfo( itemIndex )
		AddLine( "item", name )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Merchant: Trade Item
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetMerchantItem", function( self, index ) AddLine_ItemID() end )
else
	local original_GameTooltip_SetMerchantItem = GameTooltip.SetMerchantItem
	function GameTooltip.SetMerchantItem( this, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetMerchantItem( this, index )
		local link = GetMerchantItemLink( index )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Mouseover Units
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor == "1" ) then
	local original_GameTooltip_SetUnit = GameTooltip.SetUnit
	function GameTooltip.SetUnit( this, unitID )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetUnit( this, unitID )
		local creatureType = UnitCreatureType( unitID ) or ""
		local name = UnitName( unitID )
		if ( creatureType == "Humanoid" ) or ( creatureType == "Critter" ) or ( creatureType == "Beast" ) or 
											( creatureType == "Non-combat Pet" ) then
			AddLine( "NPC", name )
		end
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Profession Skill List Pane - Results & Reagents
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "6" ) then
	-- Whole profession interface overhauled for Legion
	hooksecurefunc( GameTooltip, "SetRecipeResultItem", function( self, recipeID ) AddLine_ItemID() end )
	hooksecurefunc( GameTooltip, "SetRecipeReagentItem", function( self, recipeID, reagentIndex ) AddLine_ItemID() end )
elseif ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetTradeSkillItem", 
		function( self, itemIndex, reagentIndex )
			local link = ( reagentIndex == nil ) and GetTradeSkillItemLink( itemIndex ) or
						GetTradeSkillReagentItemLink( itemIndex, reagentIndex )
			AddLine_ItemLink( link )
		end )
else
	local original_GameTooltip_SetTradeSkillItem = GameTooltip.SetTradeSkillItem
	function GameTooltip.SetTradeSkillItem( this, itemIndex, reagentIndex )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetTradeSkillItem( this, itemIndex, reagentIndex )
		local link = reagentIndex and GetTradeSkillReagentItemLink( itemIndex, reagentIndex ) or
											GetTradeSkillItemLink( itemIndex )
		AddLine_ItemLink( link )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end
	
--------------------------------------------------------------------------------------------------------------------------------------------
-- Quest Items Rewards (prior to accepting the quest / at hand in)
--------------------------------------------------------------------------------------------------------------------------------------------

-- Had to use OnUpdate to show "Required Items" when speaking to NPC (when not ready) to hand in the quest. No Tooltip in vanilla

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetQuestItem", 
		function( self, rewardType, index )
			if ( self:GetOwner().objectType == "item" ) then
				local itemLink = GetQuestItemLink( rewardType, index )
				AddLine_ItemLink( itemLink )
			end
		end )
else
	local original_GameTooltip_SetQuestItem = GameTooltip.SetQuestItem
	function GameTooltip.SetQuestItem( this, rewardType, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetQuestItem( this, rewardType, index )
		local itemLink = GetQuestItemLink( rewardType, index )
		AddLine_ItemLink( itemLink )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Quest Log Items Rewards (an accepted quest with fixed and/or choice of rewards)
--------------------------------------------------------------------------------------------------------------------------------------------

if ( buildVersionMajor > "1" ) then
	hooksecurefunc( GameTooltip, "SetQuestLogItem", 
		function( self, rewardType, index ) 
			if ( self:GetOwner().objectType == "item" ) then
				local itemLink = GetQuestLogItemLink( rewardType, index )
				AddLine_ItemLink( itemLink )
			end
		end )
else
	-- rewardType is "reward" or "choice" or ?
	local original_GameTooltip_SetQuestLogItem = GameTooltip.SetQuestLogItem
	function GameTooltip.SetQuestLogItem( this, rewardType, index )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetQuestLogItem( this, rewardType, index )
		local itemLink = GetQuestLogItemLink( rewardType, index )
		AddLine_ItemLink( itemLink )
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Quest Special Use Items (clickable and displayed on the right side of the UI)
--------------------------------------------------------------------------------------------------------------------------------------------

-- New in Legion?

if ( buildVersionMajor > "6" ) then
	hooksecurefunc( GameTooltip, "SetQuestLogSpecialItem", function() AddLine_ItemID() end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Spells
--------------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

if ( buildVersionMajor > "7" ) then
	hooksecurefunc( GameTooltip, "SetSpellByID", function( spellID ) AddLine( "spell", spellID) end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Player's Buffs and Debuffs
--------------------------------------------------------------------------------------------------------------------------------------------

-- Tested 1.12.1 (5875) 19/9/2006
-- In Vanilla / TBC we had to hook SetPlayerBuff and it gave us precious little, such as a texture. Even then we had to seed it with
-- GetPlayerBuff. And, the "index" of the buffs along the top right of the screen didn't match that of the Target buff/debuff system.
-- For all that effort we got nothing

if ( buildVersionMajor > "2" ) then
	hooksecurefunc( GameTooltip, "SetUnitAura", 		
		-- Added WotLK 3.0.2 and removed for Cata for targets (I think? SetUnitBuff/Debuff took over Cata+)
		function( self, unitID, index, filter )
			local spellID = select( 11, UnitAura( unitID, index, filter ) )
			if spellID then
				AddLine( "spell", tostring( spellID ) )
			else
				AddLine_Spell()
			end
		end )
else
	local original_GameTooltip_SetPlayerBuff = GameTooltip.SetPlayerBuff		-- Removed WotLK 3.0.2
	function GameTooltip.SetPlayerBuff( this, buffID )
		GetPlayerBuff( buffID, "HELPFUL|HARMFUL|PASSIVE" )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetPlayerBuff( this, buffID )
		AddLine_Spell()
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Target's Buffs
--------------------------------------------------------------------------------------------------------------------------------------------

-- Tested 1.12.1 (5875) 19/9/2006
-- SpellIDs were only added in WotLK 3.3.0. Vanilla could not obtain a Spell Name, only a texture
-- Double check for Patch 3.3 that we come here and still not to SetUnitAura (above)

if ( buildVersionMajor > "3" ) or ( ( buildVersionMajor == "3" ) and ( buildVersionMinor >= "3" ) ) then
	hooksecurefunc( GameTooltip, "SetUnitBuff", 
		function( self, unitID, index )
			local spellID = select( 11, UnitAura( unitID, index ) )
			if spellID then
				AddLine( "spell", tostring( spellID ) )
			else
				AddLine_Spell()
			end
		end )
else
	local original_GameTooltip_SetUnitBuff = GameTooltip.SetUnitBuff
	function GameTooltip.SetUnitBuff( this, unitID, index, raidFilter )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetUnitBuff( this, unitID, index, raidFilter )
		if ( buildVersionMajor == "1" ) then
			AddLine_Spell()
		else
			local name = UnitBuff( unitID, index )
			AddLine( "SpellName", name )
		end
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Target's Debuffs
--------------------------------------------------------------------------------------------------------------------------------------------

-- SpellIDs were only added in WotLK 3.3.0. Vanilla could not obtain a Spell Name, only a texture

if ( buildVersionMajor > "3" ) or ( ( buildVersionMajor == "3" ) and ( buildVersionMinor >= "3" ) ) then
	hooksecurefunc( GameTooltip, "SetUnitDebuff", 
		function( self, unitID, index )
			local spellID = select( 11, UnitAura( unitID, index ) )
			if spellID then
				AddLine( "spell", tostring( spellID ) )
			else
				AddLine_Spell()
			end
		end )
else
	local original_GameTooltip_SetUnitDebuff = GameTooltip.SetUnitDebuff
	function GameTooltip.SetUnitDebuff( this, unitID, index, raidFilter )
		local r1, r2, r3, r4, r5, r6, r7, r8 = original_GameTooltip_SetUnitDebuff( this, unitID, index, raidFilter )
		if ( buildVersionMajor == "1" ) then
			AddLine_Spell()
		else
			local name = UnitDebuff( unitID, index )
			AddLine( "SpellName", name )
		end
		return r1, r2, r3, r4, r5, r6, r7, r8
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Toybox of the Collections Frame
--------------------------------------------------------------------------------------------------------------------------------------------

-- New with WoD. Certainly some pirate stuff in the Toybox!
-- 8.0.1

if ( buildVersionMajor > "5" ) then
	hooksecurefunc( GameTooltip, "SetToyByItemID", function( itemID ) AddLine_ItemID() end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
-- Void Storage
--------------------------------------------------------------------------------------------------------------------------------------------

-- Added Cata 4.3.0

if ( buildVersionMajor > "4" ) or ( ( buildVersionMajor == "4" ) and ( buildVersionMinor >= "3" ) ) then
	-- Void Storage item to be deposited
	hooksecurefunc( GameTooltip, "SetVoidDepositItem", function( self, index ) AddLine_ItemID() end )
	-- Void Storage item already deposited
	hooksecurefunc( GameTooltip, "SetVoidItem", function( self, one, locationIndex ) AddLine_ItemID() end )
	-- Void Storage item to be withdrawn
	hooksecurefunc( GameTooltip, "SetVoidWithdrawalItem", function( self, index ) AddLine_ItemID() end )
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		OnUpdate
--		========
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- Typically this is where I put hacks until I can find an appropriate function to hook. Sigh. Careful as may cause duplicates

local timeSinceLastUpdate = 0

local function OnUpdateHandler()

	-- From a certain patch/update the timeElapsed was passed as a value. But this block should work across all versions of WoW.
	-- Actually timeElapsed ignores the time elapsed while looking at a loading screen or a cinematic. GetTime is better
	-- Note that Blizzard themselves use '( prevUpdate < ( self.updateTooltip or TOOLTIP_UPDATE_TIME ) )' but this causes flicker for me

	local curTime = GetTime()
	if curTime - timeSinceLastUpdate <= 0.1 then return end
	timeSinceLastUpdate = curTime

	----------------------------------------------------------------------------------------------------------------------------------------
	-- Quest Progress Required Items
	----------------------------------------------------------------------------------------------------------------------------------------

-- NEEDS TESTING

	local frame = EnumerateFrames()
	while frame do
		if ( frame:IsVisible() and MouseIsOver( frame) ) then
			local frameName = frame:GetName()
			if frameName then
				local _, _, prefix, i = find( frameName, "(%w+)(%d+)" )
				if ( prefix == "QuestProgressItem" ) then
					local text = _G["QuestProgressItem"..i.."Name"]:GetText()
					GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
					GameTooltip:SetText( text )
					AddLine( "item", text )
					break
				end
			end
		end
		frame = EnumerateFrames(frame)
	end

	----------------------------------------------------------------------------------------------------------------------------------------
	-- Targeted Units - when mouse over a unit
	----------------------------------------------------------------------------------------------------------------------------------------

	-- Maybe a player with a fishing style name which triggers this? Whatever!
	-- This will catch mouse overs and targets. NPCs and pets / companions
	
	local unitName = UnitName( "mouseover" )
	local found = false
	if unitName then
		for i = GameTooltip:NumLines(), 1, -1 do
			local line = _G["GameTooltipTextLeft"..GameTooltip:NumLines() ]:GetText()
			if ( savedPun == line ) then
				found = true
				break
			end
		end
		if not found then
			AddLine( "NPC", unitName )
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Events
--		======
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- Hooks for after most/all of the UI has been loaded

-- Unlike my "Tip" AddOn, we do not have a standard format with which to test to see if the Tooltip already has something added by Scampi.
-- Without a test, puns will just get added to the foot of the Tooltip at a rapid pace.
-- A time delay in seconds prevents this, so long as the player does not display the tooltip longer than this number of seconds.
-- A long delay also avoids the player becoming annoyed if they happen to be continuously doing something with the same items/spells/NPCs.
		
local function OnEventHandler( frame, theEvent, arg )

	-- Prior to Patch 4.0.1, the globals "event", "arg1", etc were automagically setup by Blizzard. No variables were passed
	-- From Patch 4.0.1 "self", "event", and varag "args" are passed. Renamed here from normal conventions to avoid conflicts

	if ( theEvent == "VARIABLES_LOADED" ) or ( event == "VARIABLES_LOADED" ) then
		if not ScampiDB then ScampiDB = {} end
		local delayTemp = ScampiDB.delay or defaultDelay
		local addSpaceLine = ScampiDB.addSpaceLine or "n"
		ScampiDB = {}
		ScampiDB.delay = delayTemp
		ScampiDB.addSpaceLine = addSpaceLine
		
		addonTitle = GetAddOnMetadata( addonName, "Title" )
		spaceLine = ( ScampiDB.addSpaceLine == "y" ) and "\n" or ""
	end
end

local eventFrame = CreateFrame( "Frame" )
eventFrame:RegisterEvent( "VARIABLES_LOADED" )
eventFrame:SetScript( "OnEvent", OnEventHandler )
eventFrame:SetScript( "OnUpdate", OnUpdateHandler )

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Slash Commands
--		==============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local soundHandle, punCID = nil, 0

SLASH_ThisScampiHappening1 = "/scampi"

SlashCmdList[ "ThisScampiHappening" ] = function( options )

	local options1, secondParm;
	for v in gmatch( options, "(%S+)" ) do
		options = lower( v )
		if not options1 then
			options1 = sub( options,1,1 )
		else
			secondParm = v
			break
		end
	end

	if not options1 or ( options1 == "?" ) then
		printPC( pc_colour_Highlight .. "Commands:\n"..
			pc_colour_Highlight.. "1".. pc_colour_PlainText.. " = random in General Chat\n"..
			pc_colour_Highlight.. "2".. pc_colour_PlainText.. " = random in Trade Chat\n"..
			pc_colour_Highlight.. "r".. pc_colour_PlainText.. " = random Yell\n"..
			pc_colour_Highlight.. "a".. pc_colour_PlainText.. " = add empty spacing line (\"y\" or \"n\". \"n\" default)\n"..
			pc_colour_Highlight.. "d".. pc_colour_PlainText.. " = tooltip delay in seconds ("..defaultDelay.." default)\n"..
			pc_colour_Highlight.. "v".. pc_colour_PlainText.. " = Show the version number\n")

	elseif ( options1 == "1" ) or ( options1 == "2" ) or ( options1 == "r" ) then
		local punCIDnew = random( numPuns )
		while ( punCID == punCIDnew ) do
			punCIDnew = random( numPuns )
		end
		punCID = punCIDnew
		local pun = puns[ punCIDnew ]
		pun = gsub( pun, ", %%p", "." )
		pun = gsub( pun, " %%p", "" )
		pun = gsub( pun, "\n\n", " " )
		pun = gsub( pun, "\n", " " )
	
		if ( options1 == "1" ) or ( options1 == "2" ) then
			SendChatMessage( pun, "CHANNEL", nil, tonumber( options1 ) )
		else
			SendChatMessage( pun, "YELL" )
		end

	elseif ( options1 == "a" ) then
		local changed = false
		if secondParm and ( ( secondParm == "n" ) or ( secondParm == "y" ) ) then
			if ( secondParm ~= ScampiDB.addSpaceLine ) then changed = true end
			ScampiDB.addSpaceLine = secondParm
			spaceLine = ( secondParm == "y" ) and "\n" or ""
		end
		printPC( pc_colour_Highlight.. "a".. pc_colour_PlainText.. " = ".. pc_colour_Highlight.. ScampiDB.addSpaceLine )
		if ( changed == false ) then
			printPC( "(Default = \"n\")" )
		end

	elseif ( options1 == "d" ) then
		local parm = tonumber( secondParm )
		local changed = false
		if parm then
			if ( parm < 15 ) then
				printPC( "There must be some delay to prevent spamming yourself. Minimum is 15 seconds" )
			elseif ( parm > 3600 ) then
				printPC( "There is an arbitrary upper limit of 3600 seconds. Perhaps disable the AddOn?" )
			else
				local oldValue = ScampiDB.delay
				ScampiDB.delay = parm
				if ( oldValue ~= parm ) then changed = true end
			end
		end
		printPC( pc_colour_Highlight.. "d".. pc_colour_PlainText.. " = ".. pc_colour_Highlight.. ScampiDB.delay )
		if ( changed == false ) then
			printPC( "(Default = "..defaultDelay..")" )
			SlashCmdList[ "Yarrr" ]("")
		end

	elseif ( options1 == "v" ) then
		local version = GetAddOnMetadata( addonName, "Version" )
		printPC( pc_colour_Highlight.. "Version: ".. pc_colour_PlainText.. " = ".. pc_colour_Highlight.. version )

	-- Easter Eggs. Enjoy!

	elseif ( options == "zz" ) then
		if ( buildVersionMajor >= "5" ) then
			if soundHandle then 
				StopSound( soundHandle, 5000 )
				soundHandle = nil
				return
			end
		end
	elseif ( options1 == "z" ) then
		if ( buildVersionMajor >= "5" ) then
			local soundID = ( random( 5 ) == 5 ) and 32589 or 416
			if ( buildVersionMajor > "7" ) or ( ( buildVersionMajor == "7" ) and ( buildVersionMinor >= "3" ) ) then
				_, soundHandle = PlaySound( soundID )
			else
				_, soundHandle = PlaySoundKitID( soundID )
			end
		else
			PlaySoundFile("Sound\\Creature\\Murloc\\mMurlocAggroOld.wav" )
		end
	end
end